## zxing-cpp 3.0.2+ds

=== CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2025 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.10)
project(zint-package)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(ZINT_VERSION_MAJOR 2)
set(ZINT_VERSION_MINOR 16)
set(ZINT_VERSION_RELEASE 0)
set(ZINT_VERSION_BUILD 0) # Set to 0 before release, set to 9 after release
set(ZINT_VERSION "${ZINT_VERSION_MAJOR}.${ZINT_VERSION_MINOR}.${ZINT_VERSION_RELEASE}.${ZINT_VERSION_BUILD}")

add_definitions(-DZINT_VERSION=\"${ZINT_VERSION}\")

option(ZINT_DEBUG     "Set debug compile flags"         OFF)
option(ZINT_NOOPT     "Set no optimize compile flags"   OFF)
option(ZINT_SANITIZE  "Set sanitize address/undefined"  OFF)
option(ZINT_SANITIZEM "Set sanitize memory (ignored if ZINT_SANITIZE)" OFF)
option(ZINT_TEST      "Set test compile flag"           OFF)
option(ZINT_COVERAGE  "Set code coverage flags"         OFF)
option(ZINT_SHARED    "Build shared library"            ON)
option(ZINT_STATIC    "Build static library"            OFF)
option(ZINT_FRONTEND  "Build frontend"                  ON)
option(ZINT_USE_GS1SE "Build with GS1 Syntax Engine"    ON)
option(ZINT_USE_PNG   "Build with PNG support"          ON)
option(ZINT_USE_QT    "Build with Qt support"           ON)
option(ZINT_QT6       "If ZINT_USE_QT, use Qt6"         OFF)
option(ZINT_UNINSTALL "Add uninstall target"            ON)

if(NOT ZINT_SHARED AND NOT ZINT_STATIC)
    message(SEND_ERROR "Either ZINT_SHARED or ZINT_STATIC or both must be set")
endif()

include(GNUInstallDirs)
# Taken from old (2008) KDE "SetPaths.cmake"
# Set a default build type for single-configuration CMake generators if no build type is set
if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

include(CheckCCompilerFlag)
include(CheckFunctionExists)

if(NOT MSVC) # Use default warnings if MSVC otherwise inundated
    check_c_compiler_flag("-Wall" C_COMPILER_FLAG_WALL)
    if(C_COMPILER_FLAG_WALL)
        add_compile_options("-Wall")
    endif()

    check_c_compiler_flag("-Wextra" C_COMPILER_FLAG_WEXTRA)
    if(C_COMPILER_FLAG_WEXTRA)
        add_compile_options("-Wextra")
    endif()

    check_c_compiler_flag("-Wpedantic" C_COMPILER_FLAG_WPEDANTIC)
    if(C_COMPILER_FLAG_WPEDANTIC)
        add_compile_options("-Wpedantic")
    endif()

    check_c_compiler_flag("-Wcast-align" C_COMPILER_FLAG_WCASTALIGN)
    if(C_COMPILER_FLAG_WCASTALIGN)
        add_compile_options("-Wcast-align")
    endif()
    check_c_compiler_flag("-Wpointer-arith" C_COMPILER_FLAG_WPOINTERARITH)
    if(C_COMPILER_FLAG_WPOINTERARITH)
        add_compile_options("-Wpointer-arith")
    endif()
    check_c_compiler_flag("-Wshadow" C_COMPILER_FLAG_WSHADOW)
    if(C_COMPILER_FLAG_WSHADOW)
        add_compile_options("-Wshadow")
    endif()
    check_c_compiler_flag("-Wundef" C_COMPILER_FLAG_WUNDEF)
    if(C_COMPILER_FLAG_WUNDEF)
        add_compile_options("-Wundef")
    endif()
    check_c_compiler_flag("-Wwrite-strings" C_COMPILER_FLAG_WWRITESTRINGS)
    if(C_COMPILER_FLAG_WWRITESTRINGS)
        add_compile_options("-Wwrite-strings")
    endif()
endif()

if(ZINT_DEBUG)
    check_c_compiler_flag("-g" C_COMPILER_FLAG_G)
    if(C_COMPILER_FLAG_G)
        add_compile_options("-g")
    endif()
endif()

if(ZINT_NOOPT)
    check_c_compiler_flag("-O0" C_COMPILER_FLAG_O0)
    if(C_COMPILER_FLAG_O0)
        add_compile_options("-O0")
    endif()
endif()

if(ZINT_SANITIZE)
    if(MSVC)
        if(MSVC_VERSION GREATER_EQUAL 1920)
            add_compile_options(-fsanitize=address)
            message(STATUS "ZINT_SANITIZE: setting -fsanitize=address for MSVC 2019")
        else()
            message(STATUS "ZINT_SANITIZE: ignoring for MSVC < 2019")
        endif()
    else()
        set(SANITIZERS address undefined leak)
        foreach(sanitizer IN ITEMS ${SANITIZERS})
            set(CMAKE_REQUIRED_LIBRARIES -fsanitize=${sanitizer})
            check_c_compiler_flag(-fsanitize=${sanitizer} C_COMPILER_FLAG_FSANITIZE_${sanitizer})
            if(C_COMPILER_FLAG_FSANITIZE_${sanitizer})
                add_compile_options(-fsanitize=${sanitizer})
                link_libraries(-fsanitize=${sanitizer})
            endif()
            unset(CMAKE_REQUIRED_LIBRARIES)
        endforeach()

        if(CMAKE_C_COMPILER_ID MATCHES "Clang")
            # Recent clangs added deprecation warnings for `sprintf()` that are only triggered on sanitize - suppress
            add_compile_options(-Wno-deprecated-declarations)
        endif()
    endif()
endif()

if(ZINT_TEST)
    enable_testing()
endif()

if(ZINT_COVERAGE)
    set(CMAKE_REQUIRED_LIBRARIES -fprofile-arcs)
    check_c_compiler_flag(--coverage C_COMPILER_FLAG_COVERAGE)
    unset(CMAKE_REQUIRED_LIBRARIES)
    if(C_COMPILER_FLAG_COVERAGE)
        add_compile_options(--coverage)
        link_libraries(-fprofile-arcs)

        check_c_compiler_flag(-O0 C_COMPILER_FLAG_O0)
        if(C_COMPILER_FLAG_O0)
            add_compile_options(-O0)
        endif()
    endif()
endif()

check_function_exists(getopt_long_only HAVE_GETOPT_LONG_ONLY)
if(NOT HAVE_GETOPT_LONG_ONLY)
    add_subdirectory(getopt)
endif()

add_subdirectory(backend)
if(ZINT_FRONTEND)
    add_subdirectory(frontend)
endif()

if(NOT ZINT_USE_QT)
    message(STATUS "Qt support was disabled for this build")
elseif(ZINT_QT6 OR ($ENV{CMAKE_PREFIX_PATH} MATCHES "6[.][0-9][.][0-9]"))
    set(USE_QT6 TRUE)
    message(STATUS "Using Qt6")
    cmake_policy(SET CMP0012 NEW) # Recognize constants in if()
    cmake_policy(SET CMP0072 NEW) # Choose OpenGL over legacy GL
    find_package(Qt6Widgets)
    find_package(Qt6Gui)
    find_package(Qt6UiTools)
    find_package(Qt6Svg)

    if(Qt6Widgets_FOUND AND Qt6Gui_FOUND AND Qt6UiTools_FOUND AND Qt6Svg_FOUND)
        message(STATUS "Qt version: " ${Qt6Core_VERSION_MAJOR}.${Qt6Core_VERSION_MINOR}.${Qt6Core_VERSION_PATCH})
        add_subdirectory(backend_qt)
        add_subdirectory(frontend_qt)
    else()
        message(STATUS "Could NOT find Qt6")
    endif()
else()
    message(STATUS "Using Qt5")
    find_package(Qt5Widgets)
    find_package(Qt5Gui)
    find_package(Qt5UiTools)
    find_package(Qt5Svg)

    if(Qt5Widgets_FOUND AND Qt5Gui_FOUND AND Qt5UiTools_FOUND AND Qt5Svg_FOUND)
        message(STATUS "Qt version: " ${Qt5Core_VERSION_STRING})
        # Old Qt does not provide QT_VERSION_MAJOR
        if (NOT QT_VERSION_MAJOR)
            string(SUBSTRING ${Qt5Core_VERSION_STRING} 0 1 QT_VERSION_MAJOR)
        endif()
        add_subdirectory(backend_qt)
        add_subdirectory(frontend_qt)
    else()
        message(STATUS "Could NOT find Qt5")
    endif()
endif()

if(ZINT_UNINSTALL)
    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
      "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
      IMMEDIATE @ONLY)

    add_custom_target(uninstall
      "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif()

configure_file("zint-config.cmake.in" "zint-config.cmake" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/zint-config.cmake" DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zint")

=== test/blackbox/CMakeLists.txt ===
zxing_add_package_stb()

if (ZXING_READERS)
    add_executable (ReaderTest
        TestReaderMain.cpp
        ImageLoader.h
        ImageLoader.cpp
        BlackboxTestRunner.h
        BlackboxTestRunner.cpp
    )

    target_link_libraries(ReaderTest
        ZXing::ZXing stb::stb
        $<$<AND:$<CXX_COMPILER_ID:GNU>,$<VERSION_LESS:$<CXX_COMPILER_VERSION>,9.0>>:stdc++fs>
    )

    add_test(NAME ReaderTest COMMAND ReaderTest ${CMAKE_CURRENT_SOURCE_DIR}/../samples)
endif()

if (ZXING_WRITERS)
    add_executable (WriterTest TestWriterMain.cpp)

    target_link_libraries (WriterTest ZXing::ZXing stb::stb)

    add_test(NAME WriterTest COMMAND WriterTest)
endif()

=== test/install/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(ZXingInstallTest LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17) # make sure the public API is still c++17 compatible

find_package(ZXing CONFIG REQUIRED)

add_executable(InstallTest main.cpp)

target_link_libraries(InstallTest PRIVATE ZXing::ZXing)

if (ZXING_WRITERS MATCHES "BOTH|OLD")
    add_executable(InstallTestOLD mainOLD.cpp)

    target_link_libraries(InstallTestOLD PRIVATE ZXing::ZXing)
endif()

=== test/unit/CMakeLists.txt ===
zxing_add_package(GTest googletest https://github.com/google/googletest.git v1.15.2)

if (GTest_POPULATED)
    # don't install gtest stuff on "make install"
    set (INSTALL_GTEST OFF CACHE BOOL "" FORCE)
endif()

if (MSVC)
    # default to UTF-8
    add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/utf-8>")
endif()

add_executable (UnitTest
    BarcodeFormatTest.cpp
    BitArrayUtility.cpp
    BitArrayUtility.h
    CharacterSetECITest.cpp
    ContentTest.cpp
    ErrorTest.cpp
    GTINTest.cpp
    JSONTest.cpp
    PseudoRandom.h
    SanitizerSupport.cpp
    TextUtfEncodingTest.cpp
    ZXAlgorithmsTest.cpp
)

if (ZXING_READERS)
target_sources (UnitTest PRIVATE
    PatternTest.cpp
    TextDecoderTest.cpp
    $<$<BOOL:${ZXING_ENABLE_1D}>:ThresholdBinarizerTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_AZTEC}>:aztec/AZDecoderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_AZTEC}>:aztec/AZDetectorTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_DATAMATRIX}>:datamatrix/DMDecodedBitStreamParserTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_MAXICODE}>:maxicode/MCDecoderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODCode128ReaderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODCode39ExtendedModeTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODCode39ReaderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODCode93ReaderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODDataBarExpandedBitDecoderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODDataBarReaderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_PDF417}>:pdf417/PDF417DecoderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_PDF417}>:pdf417/PDF417ErrorCorrectionTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_PDF417}>:pdf417/PDF417ScanningDecoderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/MQRDecoderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/QRBitMatrixParserTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/QRDataMaskTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/QRDecodedBitStreamParserTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/QRErrorCorrectionLevelTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/QRFormatInformationTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/QRModeTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/QRVersionTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/RMQRDecoderTest.cpp>
)
endif()

if (ZXING_WRITERS MATCHES "OLD|BOTH")
target_sources (UnitTest PRIVATE
    $<$<BOOL:${ZXING_ENABLE_AZTEC}>:aztec/AZEncoderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_DATAMATRIX}>:datamatrix/DMHighLevelEncodeTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_DATAMATRIX}>:datamatrix/DMPlacementTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_DATAMATRIX}>:datamatrix/DMSymbolInfoTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_DATAMATRIX}>:datamatrix/DMWriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODCode39WriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODCode93WriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODEAN13WriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODEAN8WriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODITFWriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODUPCAWriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODUPCEWriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_PDF417}>:pdf417/PDF417HighLevelEncoderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_PDF417}>:pdf417/PDF417WriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/QRWriterTest.cpp>
)
endif()

if (ZXING_READERS AND ZXING_WRITERS MATCHES "OLD|BOTH")
target_sources (UnitTest PRIVATE
    ReedSolomonTest.cpp
    $<$<BOOL:${ZXING_ENABLE_AZTEC}>:aztec/AZEncodeDecodeTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_AZTEC}>:aztec/AZHighLevelEncoderTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_DATAMATRIX}>:datamatrix/DMEncodeDecodeTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODCodaBarWriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_1D}>:oned/ODCode128WriterTest.cpp>
    $<$<BOOL:${ZXING_ENABLE_QRCODE}>:qrcode/QREncoderTest.cpp>
)
endif()

if (ZXING_READERS OR ZXING_WRITERS MATCHES "ON|NEW|BOTH")
target_sources (UnitTest PRIVATE
    GS1Test.cpp
)
endif()

if (ZXING_WRITERS MATCHES "ON|NEW|BOTH")
target_sources (UnitTest PRIVATE
    CreateBarcodeTest.cpp
    TextEncoderTest.cpp
)
endif()

target_include_directories (UnitTest PRIVATE .)

target_compile_options (UnitTest PRIVATE -DZXING_INTERNAL)

target_link_libraries (UnitTest ZXing::ZXing GTest::gtest_main GTest::gmock)

# target_precompile_headers(UnitTest PRIVATE ${CMAKE_SOURCE_DIR}/core/src/ZXingCpp.h) # <gtest/gtest.h>)

add_test(NAME UnitTest COMMAND UnitTest)

=== debian/changelog ===
zxing-cpp (3.0.2+ds-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 20 Feb 2026 19:09:13 -0500

=== debian/control ===
Source: zxing-cpp
Section: libs
Maintainer: Boyuan Yang <byang@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 libpython3-dev,
 libstb-dev,
# libzint-dev (>= 2.16),
 pkgconf,
 pybind11-dev,
 python3-dev:native,
 python3-numpy <!nocheck>,
 python3-opencv <!nocheck>,
 python3-pil <!nocheck>,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-multimedia-dev,
Standards-Version: 4.7.3
Homepage: https://github.com/zxing-cpp/zxing-cpp
Vcs-Git: https://salsa.debian.org/debian/zxing-cpp.git
Vcs-Browser: https://salsa.debian.org/debian/zxing-cpp
Description: C++ port of ZXing library
 ZXing-C++ ("zebra crossing") is an open-source, multi-format 1D/2D
 barcode image processing library implemented in C++.
 .
 It was originally ported from the Java ZXing library but has been
 developed further and now includes many improvements in terms of
 runtime and detection performance. It can both read and write barcodes in a
 number of formats: QR Code, DataMatrix, Aztec, PDF417, EAN/UPC,
 DataBar, Code 39, Code 93, Code 128, Codabar, ITF and more.

Package: libzxing-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libzxing4 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-multimedia-dev,
Replaces:
 libzxingcore-dev,
Breaks:
 libzxingcore-dev,
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package provides development files for zxing-cpp library.

Package: libzxing4
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (library files)
 ${source:Extended-Description}
 .
 This package provides library files for zxing-cpp library.

Package: python3-zxing-cpp
Architecture: any
Section: python
Depends:
 python3-numpy,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (python3 binding)
 ${source:Extended-Description}
 .
 This package provides python3 binding for zxing-cpp library.

Package: zxing-cpp-tools
Architecture: any
Section: utils
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Utilities provided by ZXing library
 ${source:Extended-Description}
 .
 This package provides various example utilities written with zxing-cpp
 library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1
#
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Try to export buildflags. No guarantee to be useful yet
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/buildflags.mk

# https://bugs.debian.org/1123686
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__$(DEB_HOST_ARCH_OS)_$(DEB_HOST_MULTIARCH)
endif


%:
	dh $@ --with python3

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
TEST_FLAG := ON
else
TEST_FLAG := OFF
endif

# PYTHON_EXECUTABLE: force selection of default python version
#
# UNIT_TESTS: should only be used in debug builds, disable it
# following upstream recommendation.
#
# ZXING_WRITERS: old writer backend may be needed by system
# software (e.g., libreoffice).
#
override_dh_auto_configure:
	dh_auto_configure -- \
	        -DZXING_BLACKBOX_TESTS=$(TEST_FLAG)  \
	        -DZXING_UNIT_TESTS=OFF               \
	        -DZXING_PYTHON_MODULE=ON             \
	        -DZXING_C_API=ON                     \
	        -DZXING_WRITERS=BOTH                 \
	        -DZXING_EXAMPLES=ON                  \
	        -DZXING_EXAMPLES_QT=ON               \
	        -DZXING_USE_BUNDLED_ZINT=ON          \
	        -DZXING_DEPENDENCIES=LOCAL           \
	        -DPYTHON_EXECUTABLE:FILEPATH=$(shell command -v $$(py3versions -d))

override_dh_auto_test:
	# Exclude tests that needs samples directory
	dh_auto_test -- \
	        ARGS\+=-E \
	        ARGS\+=ReaderTest\\\|ZXingCTest \
	        $(NULL)

# For importing the new upstream release:
#
# uscan --verbose --force-download ; gbp import-orig --pristine-tar --uscan --component=zint
